diff --git a/usr.sbin/sdpd/profile.h b/usr.sbin/sdpd/profile.h
index 87e4b915b4..92d0734cec 100644
--- a/usr.sbin/sdpd/profile.h
+++ b/usr.sbin/sdpd/profile.h
@@ -1,9 +1,8 @@
-/* $NetBSD: profile.h,v 1.2 2007/11/09 20:08:41 plunky Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/profile.h,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * profile.h
- *
+ */
+
+/*-
  * Copyright (c) 2004 Maksim Yevmenkin <m_evmenkin@yahoo.com>
  * All rights reserved.
  *
@@ -28,8 +27,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: profile.h,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/profile.h,v 1.1 2004/01/20 20:48:26 emax Exp $
+ * $Id: profile.h,v 1.6 2004/01/13 19:31:54 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/profile.h 177358 2008-03-18 18:21:39Z emax $
  */
 
 #ifndef _PROFILE_H_
@@ -64,8 +63,7 @@ typedef struct attr *	attr_p;
 
 struct profile
 {
-	uint16_t *		uuid;	/* profile uuid list */
-	ssize_t			usize;	/* profile uuid list size */
+	uint16_t		uuid;	/* profile uuid */
 	uint16_t		dsize;	/* profile data size */
 	profile_data_valid_p	valid;	/* profile data validator */
 	attr_t const * const	attrs;	/* supported attributes */
@@ -83,11 +81,16 @@ profile_attr_create_t	common_profile_create_bluetooth_profile_descriptor_list;
 profile_attr_create_t	common_profile_create_language_base_attribute_id_list;
 profile_attr_create_t	common_profile_create_service_provider_name;
 profile_attr_create_t	common_profile_create_string8;
+profile_attr_create_t	common_profile_create_service_availability;
 profile_attr_create_t	rfcomm_profile_create_protocol_descriptor_list;
 profile_attr_create_t	obex_profile_create_protocol_descriptor_list;
 profile_attr_create_t	obex_profile_create_supported_formats_list;
+profile_attr_create_t	bnep_profile_create_protocol_descriptor_list;
+profile_attr_create_t	bnep_profile_create_security_description;
 
+profile_data_valid_t	common_profile_always_valid;
 profile_data_valid_t	common_profile_server_channel_valid;
 profile_data_valid_t	obex_profile_data_valid;
 
 #endif /* ndef _PROFILE_H_ */
+
diff --git a/usr.sbin/sdpd/provider.c b/usr.sbin/sdpd/provider.c
index cee68ff988..0f5f4ded40 100644
--- a/usr.sbin/sdpd/provider.c
+++ b/usr.sbin/sdpd/provider.c
@@ -1,6 +1,3 @@
-/* $NetBSD: provider.c,v 1.2 2007/11/09 20:08:41 plunky Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/provider.c,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * provider.c
  *
@@ -28,22 +25,20 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: provider.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/provider.c,v 1.1 2004/01/20 20:48:26 emax Exp $
+ * $Id: provider.c,v 1.5 2004/01/13 01:54:39 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/provider.c 124758 2004-01-20 20:48:26Z emax $
  */
 
 #include <sys/queue.h>
 #include <bluetooth.h>
-#include <sdp.h>
 #include <string.h>
 #include <stdlib.h>
 #include "profile.h"
 #include "provider.h"
-#include "uuid-private.h"
 
 static TAILQ_HEAD(, provider)	providers = TAILQ_HEAD_INITIALIZER(providers);
-static uint32_t			change_state = 0;
-static uint32_t			next_handle = 0;
+static uint32_t			change_state = 0;		
+static uint32_t			handle = 0;
 
 /*
  * Register Service Discovery provider.
@@ -78,7 +73,7 @@ provider_register_sd(int32_t fd)
 	bgd->handle = 1;
 	sd->fd = fd;
 	TAILQ_INSERT_AFTER(&providers, sd, bgd, provider_next);
-
+	
 	change_state ++;
 
 	return (0);
@@ -89,7 +84,7 @@ provider_register_sd(int32_t fd)
  */
 
 provider_p
-provider_register(profile_p const profile, bdaddr_t const *bdaddr, int32_t fd,
+provider_register(profile_p const profile, bdaddr_p const bdaddr, int32_t fd,
 	uint8_t const *data, uint32_t datalen)
 {
 	provider_p	provider = calloc(1, sizeof(*provider));
@@ -105,10 +100,10 @@ provider_register(profile_p const profile, bdaddr_t const *bdaddr, int32_t fd,
 			 * for SDP itself
 			 */
 
-			if (++ next_handle <= 1)
-				next_handle = 2;
+			if (++ handle <= 1)
+				handle = 2;
 
-			provider->handle = next_handle;
+			provider->handle = handle;
 
 			memcpy(&provider->bdaddr, bdaddr,
 				sizeof(provider->bdaddr));
@@ -199,37 +194,3 @@ provider_get_change_state(void)
 	return (change_state);
 }
 
-/*
- * Match provider to UUID list
- *
- *	all UUIDs in list must match one of the
- *	provider UUIDs or the PublicBrowseGroup
- */
-
-int
-provider_match_uuid(provider_p provider, uint128_t *uuid, int ucount)
-{
-	uint128_t puuid;
-	int num, max;
-
-	max = provider->profile->usize / sizeof(provider->profile->uuid[0]);
-
-	for (; ucount-- > 0 ; uuid++) {
-		if (memcmp(uuid, &uuid_public_browse_group, sizeof(*uuid)) == 0)
-			continue;
-
-		for (num = 0 ; ; num++) {
-			if (num == max)
-				return 0;
-
-			memcpy(&puuid, &uuid_base, sizeof(puuid));
-			puuid.b[2] = provider->profile->uuid[num] >> 8;
-			puuid.b[3] = provider->profile->uuid[num];
-
-			if (memcmp(uuid, &puuid, sizeof(*uuid)) == 0)
-				break;
-		}
-	}
-
-	return 1;
-}
diff --git a/usr.sbin/sdpd/provider.h b/usr.sbin/sdpd/provider.h
index a1eeca4a60..46f362e3ec 100644
--- a/usr.sbin/sdpd/provider.h
+++ b/usr.sbin/sdpd/provider.h
@@ -1,34 +1,3 @@
-/* $NetBSD: provider.h,v 1.2 2007/11/09 20:08:41 plunky Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/provider.h,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
-/*-
- * Copyright (c) 2006 Itronix Inc.
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. The name of Itronix Inc. may not be used to endorse
- *    or promote products derived from this software without specific
- *    prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY ITRONIX INC. ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
- * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
- * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL ITRONIX INC. BE LIABLE FOR ANY
- * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
- * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
 /*
  * provider.h
  *
@@ -56,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: provider.h,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/provider.h,v 1.1 2004/01/20 20:48:26 emax Exp $
+ * $Id: provider.h,v 1.6 2004/01/13 01:54:39 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/provider.h 124758 2004-01-20 20:48:26Z emax $
  */
 
 #ifndef _PROVIDER_H_
@@ -71,7 +40,7 @@ struct profile;
 
 struct provider
 {
-	struct profile		*profile;		/* profile */
+	struct profile 		*profile;		/* profile */
 	void			*data;			/* profile data */
 	uint32_t		 handle;		/* record handle */
 	bdaddr_t		 bdaddr;		/* provider's BDADDR */
@@ -83,12 +52,13 @@ typedef struct provider		provider_t;
 typedef struct provider	*	provider_p;
 
 #define		provider_match_bdaddr(p, b) \
-	(bdaddr_any(b) || bdaddr_any(&(p)->bdaddr) || \
-	 bdaddr_same(&(p)->bdaddr, (b)))
-
+	(memcmp(b, NG_HCI_BDADDR_ANY, sizeof(bdaddr_t)) == 0 || \
+	 memcmp(&(p)->bdaddr, NG_HCI_BDADDR_ANY, sizeof(bdaddr_t)) == 0 || \
+	 memcmp(&(p)->bdaddr, b, sizeof(bdaddr_t)) == 0)
+	
 int32_t		provider_register_sd		(int32_t fd);
 provider_p	provider_register		(profile_p const profile,
-						 bdaddr_t const *bdaddr,
+						 bdaddr_p const bdaddr,
 						 int32_t fd,
 						 uint8_t const *data,
 						 uint32_t datalen);
@@ -102,10 +72,4 @@ provider_p	provider_get_first		(void);
 provider_p	provider_get_next		(provider_p provider);
 uint32_t	provider_get_change_state	(void);
 
-int		provider_match_uuid		(provider_p provider,
-						 uint128_t *ulist, int ucount);
-
-int32_t server_prepare_attr_list(provider_p const, uint8_t const *, uint8_t const *,
-		uint8_t *, uint8_t const *);
-
 #endif /* ndef _PROVIDER_H_ */
diff --git a/usr.sbin/sdpd/sar.c b/usr.sbin/sdpd/sar.c
index 1f3ca787c7..6bd9e1b78c 100644
--- a/usr.sbin/sdpd/sar.c
+++ b/usr.sbin/sdpd/sar.c
@@ -1,6 +1,3 @@
-/* $NetBSD: sar.c,v 1.1 2006/06/19 15:44:56 gdamore Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/sar.c,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * sar.c
  *
@@ -28,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: sar.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/sar.c,v 1.2 2004/02/26 20:44:55 emax Exp $
+ * $Id: sar.c,v 1.2 2004/01/08 23:46:51 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/sar.c 126297 2004-02-26 20:44:55Z emax $
  */
 
 #include <sys/queue.h>
@@ -147,9 +144,9 @@ server_prepare_service_attribute_response(server_p srv, int32_t fd)
 	uint8_t const	*req = srv->req + sizeof(sdp_pdu_t);
 	uint8_t const	*req_end = req + ((sdp_pdu_p)(srv->req))->len;
 	uint8_t		*rsp = srv->fdidx[fd].rsp;
-	uint8_t const	*rsp_end = rsp + L2CAP_MTU_MAXIMUM;
+	uint8_t const	*rsp_end = rsp + NG_L2CAP_MTU_MAXIMUM;
 
-	uint8_t const	*ptr = NULL;
+	uint8_t		*ptr = NULL;
 	provider_t	*provider = NULL;
 	uint32_t	 handle;
 	int32_t		 type, rsp_limit, aidlen, cslen, cs;
@@ -187,17 +184,17 @@ server_prepare_service_attribute_response(server_p srv, int32_t fd)
 
 	case SDP_DATA_SEQ32:
 		SDP_GET32(aidlen, req);
-		break;
+ 		break;
 	}
 	if (aidlen <= 0)
 		return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
 
-	ptr = (uint8_t const *) req + aidlen;
+	ptr = (uint8_t *) req + aidlen;
 
 	/* Get ContinuationState */
 	if (ptr + 1 > req_end)
 		return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
-
+		
 	SDP_GET8(cslen, ptr);
 	if (cslen != 0) {
 		if (cslen != 2 || req_end - ptr != 2)
@@ -242,7 +239,7 @@ server_prepare_service_attribute_response(server_p srv, int32_t fd)
 }
 
 /*
- * Send SDP Service [Search] Attribute Response
+ * Send SDP Service [Search] Attribute Response 
  */
 
 int32_t
@@ -314,6 +311,7 @@ server_send_service_attribute_response(server_p srv, int32_t fd)
 		srv->fdidx[fd].rsp_size = 0;
 		srv->fdidx[fd].rsp_limit = 0;
 	}
-
+	
 	return ((size < 0)? errno : 0);
 }
+
diff --git a/usr.sbin/sdpd/scr.c b/usr.sbin/sdpd/scr.c
index 4ad9031c0a..7191f6f814 100644
--- a/usr.sbin/sdpd/scr.c
+++ b/usr.sbin/sdpd/scr.c
@@ -1,6 +1,3 @@
-/* $NetBSD: scr.c,v 1.1 2006/06/19 15:44:56 gdamore Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/scr.c,v 1.2 2008/05/19 10:19:49 corecode Exp $ */
-
 /*
  * scr.c
  *
@@ -28,12 +25,11 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: scr.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/scr.c,v 1.2 2005/12/06 17:56:36 emax Exp $
+ * $Id: scr.c,v 1.1 2004/01/13 01:54:39 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/scr.c 153176 2005-12-06 17:56:36Z emax $
  */
 
 #include <sys/queue.h>
-#include <sys/select.h>
 #include <bluetooth.h>
 #include <errno.h>
 #include <sdp.h>
@@ -85,7 +81,7 @@ server_prepare_service_change_response(server_p srv, int32_t fd)
 		return (SDP_ERROR_CODE_INSUFFICIENT_RESOURCES);
 
 	SDP_PUT16(0, rsp);
-
+	
 	/* Set reply size */
 	srv->fdidx[fd].rsp_limit = srv->fdidx[fd].omtu - sizeof(sdp_pdu_t);
 	srv->fdidx[fd].rsp_size = rsp - srv->fdidx[fd].rsp;
@@ -93,3 +89,4 @@ server_prepare_service_change_response(server_p srv, int32_t fd)
 
 	return (0);
 }
+
diff --git a/usr.sbin/sdpd/sd.c b/usr.sbin/sdpd/sd.c
index d45e0e8efc..21f3b79058 100644
--- a/usr.sbin/sdpd/sd.c
+++ b/usr.sbin/sdpd/sd.c
@@ -1,5 +1,3 @@
-/* $NetBSD: sd.c,v 1.2 2007/11/09 20:08:41 plunky Exp $ */
-
 /*
  * sd.c
  *
@@ -27,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: sd.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/sd.c,v 1.1 2004/01/20 20:48:26 emax Exp $
+ * $Id: sd.c,v 1.4 2004/01/13 01:54:39 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/sd.c 185320 2008-11-25 21:54:42Z emax $
  */
 
 #include <sys/queue.h>
@@ -53,6 +51,22 @@ sd_profile_create_service_class_id_list(
 			sizeof(service_classes)));
 }
 
+static int32_t
+sd_profile_create_bluetooth_profile_descriptor_list(
+		uint8_t *buf, uint8_t const * const eob,
+		uint8_t const *data, uint32_t datalen)
+{
+	static uint16_t profile_descriptor_list[] = {
+		SDP_SERVICE_CLASS_SERVICE_DISCOVERY_SERVER,
+		0x0100
+	};
+
+	return (common_profile_create_bluetooth_profile_descriptor_list(
+			buf, eob,
+			(uint8_t const *) profile_descriptor_list,
+			sizeof(profile_descriptor_list)));
+}
+
 static int32_t
 sd_profile_create_service_id(
 		uint8_t *buf, uint8_t const * const eob,
@@ -62,7 +76,7 @@ sd_profile_create_service_id(
 		return (-1);
 
 	/*
-	 * The ServiceID is a UUID that universally and uniquely identifies
+	 * The ServiceID is a UUID that universally and uniquely identifies 
 	 * the service instance described by the service record. This service
 	 * attribute is particularly useful if the same service is described
 	 * by service records in more than one SDP server
@@ -91,25 +105,23 @@ sd_profile_create_protocol_descriptor_list(
 		uint8_t *buf, uint8_t const * const eob,
 		uint8_t const *data, uint32_t datalen)
 {
-	if (buf + 13 > eob)
+	if (buf + 12 > eob)
 		return (-1);
 
 	SDP_PUT8(SDP_DATA_SEQ8, buf);
-	SDP_PUT8(11, buf);
+	SDP_PUT8(10, buf);
 
 	SDP_PUT8(SDP_DATA_SEQ8, buf);
-	SDP_PUT8(9, buf);
-
+	SDP_PUT8(3, buf);
 	SDP_PUT8(SDP_DATA_UUID16, buf);
 	SDP_PUT16(SDP_UUID_PROTOCOL_L2CAP, buf);
 
-	SDP_PUT8(SDP_DATA_UINT16, buf);
-	SDP_PUT16(L2CAP_PSM_SDP, buf);
-
-	SDP_PUT8(SDP_DATA_UINT16, buf);
-	SDP_PUT16(1, buf); /* version */
+	SDP_PUT8(SDP_DATA_SEQ8, buf);
+	SDP_PUT8(3, buf);
+	SDP_PUT8(SDP_DATA_UUID16, buf);
+	SDP_PUT16(SDP_UUID_PROTOCOL_SDP, buf);
 
-	return (13);
+	return (12);
 }
 
 static int32_t
@@ -147,8 +159,8 @@ sd_profile_create_version_number_list(
 	SDP_PUT8(SDP_DATA_SEQ8, buf);
 	SDP_PUT8(3, buf);
 
-	/*
-	 * The VersionNumberList is a data element sequence in which each
+	/* 
+	 * The VersionNumberList is a data element sequence in which each 
 	 * element of the sequence is a version number supported by the SDP
 	 * server. A version number is a 16-bit unsigned integer consisting
 	 * of two fields. The higher-order 8 bits contain the major version
@@ -184,13 +196,15 @@ static attr_t	sd_profile_attrs[] = {
 	  common_profile_create_service_record_handle },
 	{ SDP_ATTR_SERVICE_CLASS_ID_LIST,
 	  sd_profile_create_service_class_id_list },
+	{ SDP_ATTR_BLUETOOTH_PROFILE_DESCRIPTOR_LIST,
+	  sd_profile_create_bluetooth_profile_descriptor_list },
 	{ SDP_ATTR_SERVICE_ID,
 	  sd_profile_create_service_id },
 	{ SDP_ATTR_LANGUAGE_BASE_ATTRIBUTE_ID_LIST,
 	  common_profile_create_language_base_attribute_id_list },
-	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_SERVICE_NAME_OFFSET,
+	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_SERVICE_NAME_OFFSET, 
 	  sd_profile_create_service_name },
-	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_SERVICE_DESCRIPTION_OFFSET,
+	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_SERVICE_DESCRIPTION_OFFSET, 
 	  sd_profile_create_service_name },
 	{ SDP_ATTR_PRIMARY_LANGUAGE_BASE_ID + SDP_ATTR_PROVIDER_NAME_OFFSET,
 	  common_profile_create_service_provider_name },
@@ -205,15 +219,10 @@ static attr_t	sd_profile_attrs[] = {
 	{ 0, NULL } /* end entry */
 };
 
-static uint16_t sd_profile_uuids[] = {
-	SDP_SERVICE_CLASS_SERVICE_DISCOVERY_SERVER,
-	SDP_UUID_PROTOCOL_L2CAP,
-};
-
 profile_t	sd_profile_descriptor = {
-	sd_profile_uuids,
-	sizeof(sd_profile_uuids),
+	SDP_SERVICE_CLASS_SERVICE_DISCOVERY_SERVER,
 	0,
-	NULL,
+	(profile_data_valid_p) NULL,
 	(attr_t const * const) &sd_profile_attrs
 };
+
diff --git a/usr.sbin/sdpd/server.c b/usr.sbin/sdpd/server.c
index a012c2edb2..7079042f64 100644
--- a/usr.sbin/sdpd/server.c
+++ b/usr.sbin/sdpd/server.c
@@ -1,33 +1,3 @@
-/* $NetBSD: server.c,v 1.3 2007/03/18 10:00:42 plunky Exp $ */
-
-/*-
- * Copyright (c) 2006 Itronix Inc.
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. The name of Itronix Inc. may not be used to endorse
- *    or promote products derived from this software without specific
- *    prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY ITRONIX INC. ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
- * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
- * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL ITRONIX INC. BE LIABLE FOR ANY
- * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
- * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
 /*
  * server.c
  *
@@ -55,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: server.c,v 1.1.1.1 2007/11/20 11:56:11 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/server.c,v 1.2 2005/12/06 17:56:36 emax Exp $
+ * $Id: server.c,v 1.6 2004/01/13 01:54:39 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/server.c 229655 2012-01-05 21:36:45Z uqs $
  */
 
 #include <sys/param.h>
@@ -65,13 +35,11 @@
 #include <sys/queue.h>
 #include <sys/ucred.h>
 #include <sys/un.h>
-#include <sys/uio.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <assert.h>
 #include <bluetooth.h>
 #include <errno.h>
-#include <grp.h>
 #include <pwd.h>
 #include <sdp.h>
 #include <stdio.h>
@@ -88,30 +56,24 @@ static int32_t	server_process_request		(server_p srv, int32_t fd);
 static int32_t	server_send_error_response	(server_p srv, int32_t fd,
 						 uint16_t error);
 static void	server_close_fd			(server_p srv, int32_t fd);
-#if 0 /* XXX */
-static int	server_auth_check		(server_p srv, struct sockcred *cred);
-static int 	server_auth_check		(server_p srv, struct cmsgcred *cred);
-#endif
 
 /*
  * Initialize server
  */
 
 int32_t
-server_init(server_p srv, char const *control, char const *sgroup)
+server_init(server_p srv, char const *control)
 {
 	struct sockaddr_un	un;
-	struct sockaddr_bt	l2;
-	socklen_t		size;
+	struct sockaddr_l2cap	l2;
 	int32_t			unsock, l2sock;
+	socklen_t		size;
 	uint16_t		imtu;
-	int			opt;
 
 	assert(srv != NULL);
 	assert(control != NULL);
 
-	memset(srv, 0, sizeof(struct server));
-	srv->sgroup = sgroup;
+	memset(srv, 0, sizeof(*srv));
 
 	/* Open control socket */
 	if (unlink(control) < 0 && errno != ENOENT) {
@@ -127,11 +89,6 @@ server_init(server_p srv, char const *control, char const *sgroup)
 		return (-1);
 	}
 
-	opt = 1;
-#if 0
-	if (setsockopt(unsock, 0, LOCAL_CREDS, &opt, sizeof(opt)) < 0)
-		log_crit("Warning: No credential checks on control socket");
-#endif
 	memset(&un, 0, sizeof(un));
 	un.sun_len = sizeof(un);
 	un.sun_family = AF_LOCAL;
@@ -159,7 +116,7 @@ server_init(server_p srv, char const *control, char const *sgroup)
 	}
 
 	/* Open L2CAP socket */
-	l2sock = socket(PF_BLUETOOTH, SOCK_SEQPACKET, BTPROTO_L2CAP);
+	l2sock = socket(PF_BLUETOOTH, SOCK_SEQPACKET, BLUETOOTH_PROTO_L2CAP);
 	if (l2sock < 0) {
 		log_crit("Could not create L2CAP socket. %s (%d)",
 			strerror(errno), errno);
@@ -168,7 +125,7 @@ server_init(server_p srv, char const *control, char const *sgroup)
 	}
 
 	size = sizeof(imtu);
-        if (getsockopt(l2sock, BTPROTO_L2CAP, SO_L2CAP_IMTU, &imtu, &size) < 0) {
+        if (getsockopt(l2sock, SOL_L2CAP, SO_L2CAP_IMTU, &imtu, &size) < 0) {
 		log_crit("Could not get L2CAP IMTU. %s (%d)",
 			strerror(errno), errno);
 		close(unsock);
@@ -177,10 +134,10 @@ server_init(server_p srv, char const *control, char const *sgroup)
         }
 
 	memset(&l2, 0, sizeof(l2));
-	l2.bt_len = sizeof(l2);
-	l2.bt_family = AF_BLUETOOTH;
-	l2.bt_psm = L2CAP_PSM_SDP;
-	bdaddr_copy(&l2.bt_bdaddr, BDADDR_ANY);
+	l2.l2cap_len = sizeof(l2);
+	l2.l2cap_family = AF_BLUETOOTH;
+	memcpy(&l2.l2cap_bdaddr, NG_HCI_BDADDR_ANY, sizeof(l2.l2cap_bdaddr));
+	l2.l2cap_psm = htole16(NG_L2CAP_PSM_SDP);
 
 	if (bind(l2sock, (struct sockaddr *) &l2, sizeof(l2)) < 0) {
 		log_crit("Could not bind L2CAP socket. %s (%d)",
@@ -235,7 +192,7 @@ server_init(server_p srv, char const *control, char const *sgroup)
 
 	FD_ZERO(&srv->fdset);
 	srv->maxfd = (unsock > l2sock)? unsock : l2sock;
-
+	
 	FD_SET(unsock, &srv->fdset);
 	srv->fdidx[unsock].valid = 1;
 	srv->fdidx[unsock].server = 1;
@@ -322,7 +279,7 @@ server_do(server_p srv)
 	}
 
 	return (0);
-
+	
 }
 
 /*
@@ -333,9 +290,9 @@ static void
 server_accept_client(server_p srv, int32_t fd)
 {
 	uint8_t		*rsp = NULL;
-	socklen_t	 size;
-	int32_t		 cfd;
+	int32_t		 cfd, priv;
 	uint16_t	 omtu;
+	socklen_t	 size;
 
 	do {
 		cfd = accept(fd, NULL, NULL);
@@ -351,10 +308,12 @@ server_accept_client(server_p srv, int32_t fd)
 	assert(!FD_ISSET(cfd, &srv->fdset));
 	assert(!srv->fdidx[cfd].valid);
 
+	priv = 0;
+
 	if (!srv->fdidx[fd].control) {
 		/* Get local BD_ADDR */
 		size = sizeof(srv->req_sa);
-		if (getsockname(cfd,(struct sockaddr*)&srv->req_sa, &size) < 0) {
+		if (getsockname(cfd,(struct sockaddr*)&srv->req_sa,&size) < 0) {
 			log_err("Could not get local BD_ADDR. %s (%d)",
 				strerror(errno), errno);
 			close(cfd);
@@ -363,7 +322,7 @@ server_accept_client(server_p srv, int32_t fd)
 
 		/* Get outgoing MTU */
 		size = sizeof(omtu);
-	        if (getsockopt(cfd, BTPROTO_L2CAP, SO_L2CAP_OMTU, &omtu, &size) < 0) {
+	        if (getsockopt(cfd,SOL_L2CAP,SO_L2CAP_OMTU,&omtu,&size) < 0) {
 			log_err("Could not get L2CAP OMTU. %s (%d)",
 				strerror(errno), errno);
 			close(cfd);
@@ -375,25 +334,49 @@ server_accept_client(server_p srv, int32_t fd)
 		 * The minimum L2CAP MTU is 43 bytes. That means we need
 		 * 65536 / 43 = ~1524 chunks to transfer maximum packet
 		 * size with minimum MTU. The "rsp_cs" field in fd_idx_t
-		 * is 11 bit wide that gives us upto 2048 chunks.
+		 * is 11 bits wide, which gives us up to 2048 chunks.
 		 */
 
-		if (omtu < L2CAP_MTU_MINIMUM) {
+		if (omtu < NG_L2CAP_MTU_MINIMUM) {
 			log_err("L2CAP OMTU is too small (%d bytes)", omtu);
 			close(cfd);
 			return;
 		}
 	} else {
-		bdaddr_copy(&srv->req_sa.bt_bdaddr, BDADDR_ANY);
+		struct xucred	 cr;
+		struct passwd	*pw;
+
+		/* Get peer's credentials */
+		memset(&cr, 0, sizeof(cr));
+		size = sizeof(cr);
+
+		if (getsockopt(cfd, 0, LOCAL_PEERCRED, &cr, &size) < 0) {
+			log_err("Could not get peer's credentials. %s (%d)",
+				strerror(errno), errno);
+			close(cfd);
+			return;
+		}
+
+		/* Check credentials */
+		pw = getpwuid(cr.cr_uid);
+		if (pw != NULL)
+			priv = (strcmp(pw->pw_name, "root") == 0);
+		else
+			log_warning("Could not verify credentials for uid %d",
+				cr.cr_uid);
+
+		memcpy(&srv->req_sa.l2cap_bdaddr, NG_HCI_BDADDR_ANY,
+			sizeof(srv->req_sa.l2cap_bdaddr));
+
 		omtu = srv->fdidx[fd].omtu;
 	}
 
 	/*
-	 * Allocate buffer. This is an overkill, but we can not know how
+	 * Allocate buffer. This is an overkill, but we can not know how 
 	 * big our reply is going to be.
 	 */
 
-	rsp = (uint8_t *) calloc(L2CAP_MTU_MAXIMUM, sizeof(rsp[0]));
+	rsp = (uint8_t *) calloc(NG_L2CAP_MTU_MAXIMUM, sizeof(rsp[0]));
 	if (rsp == NULL) {
 		log_crit("Could not allocate response buffer");
 		close(cfd);
@@ -407,7 +390,7 @@ server_accept_client(server_p srv, int32_t fd)
 	srv->fdidx[cfd].valid = 1;
 	srv->fdidx[cfd].server = 0;
 	srv->fdidx[cfd].control = srv->fdidx[fd].control;
-	srv->fdidx[cfd].priv = 0;
+	srv->fdidx[cfd].priv = priv;
 	srv->fdidx[cfd].rsp_cs = 0;
 	srv->fdidx[cfd].rsp_size = 0;
 	srv->fdidx[cfd].rsp_limit = 0;
@@ -422,14 +405,8 @@ server_accept_client(server_p srv, int32_t fd)
 static int32_t
 server_process_request(server_p srv, int32_t fd)
 {
-	uint8_t		ctl[128];
 	sdp_pdu_p	pdu = (sdp_pdu_p) srv->req;
-	struct msghdr	msg;
-	struct iovec	iov;
 	int32_t		len, error;
-#if 0 /* XXX */
-	struct cmsghdr	*cmsg;
-#endif
 
 	assert(srv->imtu > 0);
 	assert(srv->req != NULL);
@@ -437,21 +414,10 @@ server_process_request(server_p srv, int32_t fd)
 	assert(srv->fdidx[fd].valid);
 	assert(!srv->fdidx[fd].server);
 	assert(srv->fdidx[fd].rsp != NULL);
-	assert(srv->fdidx[fd].omtu >= L2CAP_MTU_MINIMUM);
-
-	iov.iov_base = srv->req;
-	iov.iov_len = srv->imtu;
-
-	msg.msg_name = NULL;
-	msg.msg_namelen = 0;
-	msg.msg_iov = &iov;
-	msg.msg_iovlen = 1;
-	msg.msg_control = ctl;
-	msg.msg_controllen = sizeof(ctl);
-	msg.msg_flags = 0;
+	assert(srv->fdidx[fd].omtu >= NG_L2CAP_MTU_MINIMUM);
 
 	do {
-		len = recvmsg(fd, &msg, 0);
+		len = read(fd, srv->req, srv->imtu);
 	} while (len < 0 && errno == EINTR);
 
 	if (len < 0) {
@@ -466,25 +432,8 @@ server_process_request(server_p srv, int32_t fd)
 		return (-1);
 	}
 
-#if 0 /* XXX */
-	if ((cmsg = CMSG_FIRSTHDR(&msg)) != NULL
-	    && cmsg->cmsg_level == SOL_SOCKET
-	    && cmsg->cmsg_type == SCM_CREDS
-#if 0
-	    && cmsg->cmsg_len >= CMSG_LEN(SOCKCREDSIZE(0))
-#endif
-)
-	    	srv->fdidx[fd].priv = 
-		    server_auth_check(srv, (struct cmsgcred *)CMSG_DATA(cmsg));
-#if 0
-		    server_auth_check(srv, (struct sockcred *)CMSG_DATA(cmsg));
-#endif
-#else
-	srv->fdidx[fd].priv = 1;
-#endif
-
-	if (len >= sizeof(*pdu)
-	    && (sizeof(*pdu) + (pdu->len = ntohs(pdu->len))) == len) {
+	if (len >= sizeof(*pdu) &&
+	    sizeof(*pdu) + (pdu->len = ntohs(pdu->len)) == len) {
 		switch (pdu->pid) {
 		case SDP_PDU_SERVICE_SEARCH_REQUEST:
 			error = server_prepare_service_search_response(srv, fd);
@@ -551,13 +500,13 @@ server_process_request(server_p srv, int32_t fd)
 		if (error != 0)
 			log_err("Could not send SDP response to %s socket, " \
 				"pdu->pid=%d, pdu->tid=%d, error=%d",
-				srv->fdidx[fd].control? "control" : "L2CAP",
+				srv->fdidx[fd].control? "control" : "L2CAP", 
 				pdu->pid, ntohs(pdu->tid), error);
 	} else {
 		log_err("Could not process SDP request from %s socket, " \
 			"pdu->pid=%d, pdu->tid=%d, pdu->len=%d, len=%d, " \
 			"error=%d",
-			srv->fdidx[fd].control? "control" : "L2CAP",
+			srv->fdidx[fd].control? "control" : "L2CAP", 
 			pdu->pid, ntohs(pdu->tid), pdu->len, len, error);
 
 		error = server_send_error_response(srv, fd, error);
@@ -568,7 +517,7 @@ server_process_request(server_p srv, int32_t fd)
 				pdu->pid, ntohs(pdu->tid), error);
 	}
 
-	/* On error forget response (if any) */
+	/* On error forget response (if any) */ 
 	if (error != 0) {
 		srv->fdidx[fd].rsp_cs = 0;
 		srv->fdidx[fd].rsp_size = 0;
@@ -638,39 +587,3 @@ server_close_fd(server_p srv, int32_t fd)
 	}
 }
 
-#if 0 /* XXX */
-static int
-/*server_auth_check(server_p srv, struct sockcred *cred)*/
-server_auth_check(server_p srv, struct cmsgcred *cred)
-{
-	struct group *grp;
-	int n;
-
-	if (cred == NULL)
-		return 0;
-
-	if (cred->cmcred_uid == 0 || cred->cmcred_euid == 0)
-		return 1;
-
-	if (srv->sgroup == NULL)
-		return 0;
-
-	grp = getgrnam(srv->sgroup);
-	if (grp == NULL) {
-		log_err("No gid for group '%s'", srv->sgroup);
-		srv->sgroup = NULL;
-		return 0;
-	}
-
-
-	if (cred->cmcred_gid == grp->gr_gid)
-		return 1;
-
-	for (n = 0 ; n < cred->cmcred_ngroups ; n++) {
-		if (cred->cmcred_groups[n] == grp->gr_gid)
-			return 1;
-	}
-
-	return 0;
-}
-#endif
diff --git a/usr.sbin/sdpd/server.h b/usr.sbin/sdpd/server.h
index 74411d18c0..50954eec65 100644
--- a/usr.sbin/sdpd/server.h
+++ b/usr.sbin/sdpd/server.h
@@ -1,34 +1,3 @@
-/* $NetBSD: server.h,v 1.3 2007/11/09 20:08:41 plunky Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/server.h,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
-/*-
- * Copyright (c) 2006 Itronix Inc.
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. The name of Itronix Inc. may not be used to endorse
- *    or promote products derived from this software without specific
- *    prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY ITRONIX INC. ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
- * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
- * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL ITRONIX INC. BE LIABLE FOR ANY
- * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
- * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
 /*
  * server.h
  *
@@ -56,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: server.h,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/server.h,v 1.2 2005/12/06 17:56:36 emax Exp $
+ * $Id: server.h,v 1.5 2004/01/13 01:54:39 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/server.h 153176 2005-12-06 17:56:36Z emax $
  */
 
 #ifndef _SERVER_H_
@@ -90,13 +59,12 @@ typedef struct fd_idx *	fd_idx_p;
 
 struct server
 {
-	uint16_t		 imtu;		/* incoming MTU */
+	uint32_t		 imtu;		/* incoming MTU */
 	uint8_t			*req;		/* incoming buffer */
 	int32_t			 maxfd;		/* max. descriptor is the set */
 	fd_set			 fdset;		/* current descriptor set */
 	fd_idx_p		 fdidx;		/* descriptor index */
-	struct sockaddr_bt	 req_sa;	/* local address */
-	const char		*sgroup;	/* privileged group */
+	struct sockaddr_l2cap	 req_sa;	/* local address */
 };
 
 typedef struct server	server_t;
@@ -106,12 +74,10 @@ typedef struct server *	server_p;
  * External API
  */
 
-int32_t	server_init(server_p srv, const char *control, char const *sgroup);
+int32_t	server_init(server_p srv, const char *control);
 void	server_shutdown(server_p srv);
 int32_t	server_do(server_p srv);
 
-int	server_get_service_search_pattern(uint8_t const **buf, uint8_t const *end, uint128_t *uuid);
-
 int32_t	server_prepare_service_search_response(server_p srv, int32_t fd);
 int32_t	server_send_service_search_response(server_p srv, int32_t fd);
 
